src/Entity/User.php
<?php

namespace App\Entity;

use ApiPlatform\Core\Annotation\ApiResource;
use App\Entity\Trait\BlameableEntity;
use App\Repository\UserRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;
use Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface;
use Symfony\Component\Security\Core\User\UserInterface;
use Symfony\Component\Serializer\Annotation\Groups;
use App\Entity\Trait\TimestampableEntity;

#[ORM\Entity(repositoryClass: UserRepository::class)]
#[ApiResource (
 denormalizationContext: ['groups' => ['user:write']],
 normalizationContext: ['groups' => ['user:read', 'user:read']],
)]
#[UniqueEntity(fields: ['username'])]
#[UniqueEntity(fields: ['email'])]
#[UniqueEntity(fields: ['email'], message: 'There is already an account with this email')]
class User implements UserInterface, PasswordAuthenticatedUserInterface
{
    use TimestampableEntity;
    
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column(type: 'integer')]
    private $id;

    #[ORM\Column(type: 'string', length: 180, unique: true)]
    #[Groups(['user:read', 'user:write'])]
    #[Assert\NotBlank]
    #[Assert\Email]
    private $email;

    #[ORM\Column(type: 'json')]
    private $roles = [];

    #[ORM\Column(type: 'string')]
    #[Groups(['user:write'])]
    private $password;

    #[ORM\Column(type: 'string', length: 255, unique: true)]
    #[Groups(['users:read', 'user:write'])]
    #[Assert\NotBlank]
    private $username;

    private $plainPassword;

    #[ORM\Column(nullable: true)]
    private ?string $avatar;

    #[ORM\Column(type: 'string')]
    #[Assert\NotBlank]
    private $adress;

    #[ORM\Column(type: 'string')]
    #[Assert\NotBlank]
    private $region;

    #[ORM\Column(type: 'string')]
    #[Assert\NotBlank]
    private $firstname;

    #[ORM\Column(type: 'string')]
    #[Assert\NotBlank]
    private $country;

    #[ORM\Column(type: 'integer')]
    #[Assert\NotBlank]
    private $postcode;

    #[ORM\Column(type: 'string')]
    #[Assert\NotBlank]
    private $lastname;

    #[ORM\Column(type: 'boolean')]
    private bool $enabled = true;

    #[ORM\Column(type: 'boolean')]
    private $isVerified = false;

    #[ORM\OneToMany(mappedBy: 'user', targetEntity: Order::class)]
    private Collection $productOrder;

    #[ORM\Column(length: 255)]
    private ?string $city = null;

    #[ORM\ManyToMany(targetEntity: News::class, mappedBy: 'user')]
    private Collection $news;

    #[ORM\ManyToMany(targetEntity: Concert::class, mappedBy: 'user')]
    private Collection $concerts;

    #[ORM\ManyToMany(targetEntity: Gallery::class, mappedBy: 'user')]
    private Collection $galleries;

    public function __construct()
    {
        $this->productOrder = new ArrayCollection();
        $this->news = new ArrayCollection();
        $this->concerts = new ArrayCollection();
        $this->galleries = new ArrayCollection();
    }

     public function __toString(): string
    {
        return $this->getFullName();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getEmail(): ?string
    {
        return $this->email;
    }

    public function setEmail(string $email): self
    {
        $this->email = $email;

        return $this;
    }

    /**
     * A visual identifier that represents this user.
     *
     * @see UserInterface
     */
    public function getUserIdentifier(): string
    {
        return (string) $this->email;
    }

    /**
     * @see UserInterface
     */
    public function getRoles(): array
    {
        $roles = $this->roles;
        // guarantee every user at least has ROLE_USER
        $roles[] = 'ROLE_USER';

        return array_unique($roles);
    }

    public function setRoles(array $roles): self
    {
        $this->roles = $roles;

        return $this;
    }

    /**
     * @see PasswordAuthenticatedUserInterface
     */
    public function getPassword(): string
    {
        return $this->password;
    }

    public function setPassword(string $password): self
    {
        $this->password = $password;

        return $this;
    }

    /**
     * @see UserInterface
     */
    public function eraseCredentials()
    {
        // If you store any temporary, sensitive data on the user, clear it here
        $this->plainPassword = null;
    }

    public function getUsername(): ?string
    {
        return $this->username;
    }

    public function setUsername(string $username): self
    {
        $this->username = $username;

        return $this;
    }

    public function getAdress(): ?string
    {
        return $this->adress;
    }

    public function setAdress(string $adress): self
    {
        $this->adress = $adress;
        return $this;
    }

      public function getRegion(): ?string
    {
        return $this->region;
    }

    public function setRegion(string $region): self
    {
        $this->region = $region;
        return $this;
    }

       public function getFirstName(): ?string
    {
        return $this->firstname;
    }

    public function setFirstName(string $firstname): self
    {
        $this->firstname = $firstname;
        return $this;
    }

    public function getFullName(): ?string
    {
        return $this->firstname.' '.$this->lastname;
    }

    public function getCountry(): ?string
    {
        return $this->country;
    }

    public function setCountry(string $country): self
    {
        $this->country = $country;
        return $this;
    }

    public function getPostCode(): ?string
    {
        return $this->postcode;
    }

    public function setPostCode(string $postcode): self
    {
        $this->postcode = $postcode;
        return $this;
    }

    public function getLastName(): ?string
    {
        return $this->lastname;
    }

    public function setLastName(string $lastname): self
    {
        $this->lastname = $lastname;
        return $this;
    }


    public function getPlainPassword(): ?string
    {
        return $this->plainPassword;
    }

    public function setPlainPassword(string $plainPassword): self
    {
        $this->plainPassword = $plainPassword;
        return $this;
    }

    public function getAvatar(): ?string
    {
        return $this->avatar;
    }

    public function getAvatarUrl(): ?string
    {
        if (!$this->avatar) {
            return null;
        }

        if (strpos($this->avatar, '/') !== false) {
            return $this->avatar;
        }

        return sprintf('/uploads/avatars/%s', $this->avatar);
    }

    public function setAvatar(?string $avatar): void
    {
        $this->avatar = $avatar;
    }

    public function isEnabled(): bool
    {
        return $this->enabled;
    }

    public function setEnabled(bool $enabled): void
    {
        $this->enabled = $enabled;
    }

    public function getDisplayName(): string
    {
        return $this->getUsername() ?: $this->getEmail();
    }

    public function isVerified(): bool
    {
        return $this->isVerified;
    }

    public function setIsVerified(bool $isVerified): self
    {
        $this->isVerified = $isVerified;

        return $this;
    }

    /**
     * @return Collection<int, Order>
     */
    public function getProductOrder(): Collection
    {
        return $this->productOrder;
    }

    public function addProductOrder(Order $productOrder): self
    {
        if (!$this->productOrder->contains($productOrder)) {
            $this->productOrder->add($productOrder);
            $productOrder->setUser($this);
        }

        return $this;
    }

    public function removeProductOrder(Order $productOrder): self
    {
        if ($this->productOrder->removeElement($productOrder)) {
            // set the owning side to null (unless already changed)
            if ($productOrder->getUser() === $this) {
                $productOrder->setUser(null);
            }
        }

        return $this;
    }

    public function getCity(): ?string
    {
        return $this->city;
    }

    public function setCity(string $city): self
    {
        $this->city = $city;

        return $this;
    }

    /**
     * @return Collection<int, News>
     */
    public function getNews(): Collection
    {
        return $this->news;
    }

    public function addNews(News $news): self
    {
        if (!$this->news->contains($news)) {
            $this->news->add($news);
            $news->addUser($this);
        }

        return $this;
    }

    public function removeNews(News $news): self
    {
        if ($this->news->removeElement($news)) {
            $news->removeUser($this);
        }

        return $this;
    }

    /**
     * @return Collection<int, Concert>
     */
    public function getConcerts(): Collection
    {
        return $this->concerts;
    }

    public function addConcert(Concert $concert): self
    {
        if (!$this->concerts->contains($concert)) {
            $this->concerts->add($concert);
            $concert->addUser($this);
        }

        return $this;
    }

    public function removeConcert(Concert $concert): self
    {
        if ($this->concerts->removeElement($concert)) {
            $concert->removeUser($this);
        }

        return $this;
    }

    /**
     * @return Collection<int, Gallery>
     */
    public function getGalleries(): Collection
    {
        return $this->galleries;
    }


templates/components/footer.html.twig
<footer {{ stimulus_controller ('footer')}} class="">
	<div class="d-flex justify-content-center logo-position">
		<a href="https://www.facebook.com/theattitudeband" target="_blank">
			<img src="{{ asset('images/facebook.svg') }}" alt="Facebook logo">
		</a>
		<a href="https://www.youtube.com/channel/UCzuRYh0ZjEc6gV3L8zdEbuA" target="_blank">
			<img class="ps-3" src="{{ asset('images/youtube.svg') }}" alt="Youtube logo">
		</a>
		<a href="https://www.instagram.com/theattitudeband/" target="_blank">
			<img class="ps-3" src="{{ asset('images/instagram.svg') }}" alt="Instagram logo">
		</a>
	</div>
	<p class="d-flex justify-content-center p-2">©{{ "now"|date("Y") }} The Attitude All rights reserved.</p>
</footer>

templates/components/itemshopcard.html.twig
<div {{ stimulus_controller ('itemshopcard')}} class="shop-section mt-5">

	{% for i in 1..9 %}

		<div class="shopcard-content">
			<div class="overflow-hidden">
				<a href="{{ path('app_item') }}">
					<img class="item-img" src="{{ asset('images/t-shirt.png') }}" alt="Album image">
				</a>
			</div>
			<p class="item-title text-center">T-SHIRT</p>
			<p class="item-price">9.99$</p>
			<p class="item-date mb-4">2022-12</p>
		</div>

	{% endfor %}

</div>

templates/components/musiccard.html.twig
<div {{ stimulus_controller ('musiccard')}} class="music-section">

	{% for i in 1..2 %}

		<div class="music-content">
			<div class="overflow-hidden">
				<img class="music-img" src="{{ asset('images/logo.jpg') }}" alt="Album image">
			</div>
			<p class="music-name text-center">STANDARD VINYL</p>
			<p class="music-price">$19.99</p>
			<a href="#" target="_blank">
				<button>BUY NOW</button>
			</a>
		</div>

	{% endfor %}


</div>

templates/components/navbar.html.twig
<nav {{ stimulus_controller ('navbar')}} id="nav" class="navbar fixed-top navbar navbar-expand-xl nav_master p-0" style="background-color: #161616;">
	<div class="container-fluid">
		<a class="navbar-brand p-0" href="{{ path('app_homepage') }}">
			<img class="shimmer" src="{{ asset('images/logo.svg') }}" alt="logo The Attitude" width="60">
		</a>
		<button class="navbar-toggler collapsed d-flex d-xl-none flex-column justify-content-around" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
			<span class="toggler-icon top-bar"></span>
			<span class="toggler-icon middle-bar"></span>
			<span class="toggler-icon bottom-bar"></span>
		</button>
		<div class="separator w-100"></div>
		<div class="collapse navbar-collapse justify-content-center mx-auto" id="navbarNav">
			<ul class="navbar-nav nav align-content-center text-center">
				<li class="nav-item">
					<a class="nav-link menu_items {{ app.request.get('_route') == 'app_homepage' ? "active-nav-link" : "" }}" data-bs-target="#navbarNav" id="item_color" href="{{ path('app_homepage') }}">HOME</a>
				</li>
				<li class="nav-item">
					<a class="nav-link menu_items {{ app.request.get('_route') == 'app_news' ? "active-nav-link" : "" }}" data-bs-target="#navbarNav" id="item_color" href="{{ path('app_news') }}">NEWS</a>
				</li>
				<li class="nav-item">
					<a class="nav-link menu_items {{ app.request.get('_route') == 'app_tour' ? "active-nav-link" : "" }}" data-bs-target="#navbarNav" id="item_color" href="{{ path('app_tour') }}">TOUR</a>
				</li>
				<li class="nav-item">
					<a class="nav-link menu_items {{ app.request.get('_route') == 'app_music' ? "active-nav-link" : "" }}" data-bs-target="#navbarNav" id="item_color" href="{{ path('app_music') }}">MUSIC</a>
				</li>
				<li class="nav-item">
					<a class="nav-link menu_items {{ app.request.get('_route') == 'app_gallery' ? "active-nav-link" : "" }}" data-bs-target="#navbarNav" id="item_color" href="{{ path('app_gallery') }}">GALLERY</a>
				</li>
				<li class="nav-item">
					<a class="nav-link menu_items {{ app.request.get('_route') == 'app_video' ? "active-nav-link" : "" }}" data-bs-target="#navbarNav" id="item_color" href="{{ path('app_video') }}">VIDEOS</a>
				</li>
				<li class="nav-item">
					<a class="nav-link menu_items {{ app.request.get('_route') == 'app_store' ? "active-nav-link" : "" }}" data-bs-target="#navbarNav" id="item_color" href="{{ path('app_store') }}">STORE</a>
				</li>
				{% if is_granted('IS_AUTHENTICATED_FULLY') %}
					<div class="dropdown">
						<button class="dropdown-toggle btn" type="button" id="user-dropdown" data-bs-toggle="dropdown" aria-expanded="false">
						<img class="rounded-circle" src="{{ app.user.avatarUrl }}" alt="{{ app.user.username }} Avatar" width="35px" height="35px">
						</button>
						<ul class="dropdown-menu dropdown-menu-end" aria-labelledby="user-dropdown">
							<li>
								<a class="dropdown-item" href="{{ path('app_profile_show') }}">Profile</a>
							</li>
							<li>
								<a class="dropdown-item" href="{{ path('app_logout') }}">Log Out</a>
							</li>
						</ul>
					</div>
				{% else %}
					<li class="nav-item">
						<a class="nav-link menu_items {{ app.request.get('_route') == 'app_login' ? "active-nav-link" : "" }}" data-bs-target="#navbarNav" id="item_color" href="{{ path('app_login') }}">LOGIN</a>
					</li>
				{% endif %}
			</ul>
		</div>
	</div>
</nav>

templates/components/navshop.html.twig
<nav {{ stimulus_controller ('navshop')}} id="nav" class="navbar navbar navbar-expand-lg nav_master p-0">
	<div class="container-fluid">
		<button class="navbar-toggler collapsed d-flex d-lg-none flex-column justify-content-around" type="button" data-bs-toggle="collapse" data-bs-target="#navShop" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
			<span class="toggler-icon top-bar"></span>
			<span class="toggler-icon middle-bar"></span>
			<span class="toggler-icon bottom-bar"></span>
		</button>
		<div class="collapse navbar-collapse mx-auto" id="navShop">
			<ul id="dropdown" class="w-100 navbar-nav nav flex-column">


				{% for i in 1..6 %}

					<li class="dropdown">

						<a href="#dropdownMenu{{i}}" class="nav-link px-sm-0 px-1 d-flex justify-content-between align-items-center" data-bs-toggle="collapse" aria-expanded="false">
							<span class="ms-1 d-sm-inline w-100">MUSIC</span>
							<img src="{{ asset('images/arrow-down.svg') }}" alt="Arrow down">
						</a>
						<ul id="dropdownMenu{{i}}" data-bs-parent="#dropdown" class="w-100 dropdown-menu-custom text-small border-0 collapse" aria-labelledby="dropdown" style="">
							<li>
								<a class="dropdown-item" href="#">New project...</a>
							</li>
							<li>
								<a class="dropdown-item" href="#">Settings</a>
							</li>
							<li>
								<a class="dropdown-item" href="#">Profile</a>
							</li>
							<li>
								<a class="dropdown-item" href="#">Sign out</a>
							</li>
						</ul>
					</li>

				{% endfor %}


			</ul>
		</div>
	</div>
</nav>

templates/components/parallax.html.twig
{# Parallax component  #}
<div {{ stimulus_controller ('parallax')}}>
	<p>Want your event to be loud ? Have a crazy night with us!</p>
</div>

templates/components/playcard.html.twig
<div {{ stimulus_controller ('playcard')}} class="play-section">

	{% for i in 1..8 %}

		<div class="play-content">
			<div class="overflow-hidden">
				<img class="play-img" src="{{ asset('images/logo.jpg') }}" alt="Album image">
			</div>
			<p class="play-title text-center">TITLE</p>
			<p class="play-name">PRISONER</p>
			<a class="mb-4" href="#" target="_blank">
				<button><img src="{{ asset('images/play.svg') }}"><img>LISTEN</button>
			</a>
		</div>

	{% endfor %}

</div>